#ident "@(#) $Id$"

/*
 *
 *    Copyright (c) 1996-2001 Brocade Communications Systems, Inc.
 *
 *    Description:
 *      PHY Vendor and model identifiers.
 *
 */

#ifndef __PHYID_H__
#define __PHYID_H__

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Please keep these sorted on vendor ID and then by model ID!
 */

#define	PHY_OUI_AMD		0x00001A	/* AMD */
#define	PHY_MODEL_AMD_79C901A_10BT	0x370	/* AMD 79C901A 10-Base-T */
#define	PHY_MODEL_AMD_79C901A_HPNA	0x390	/* AMD 79C901A Home PNA */

#define	PHY_OUI_ICS		0x00057D	/* ICS */
#define	PHY_MODEL_ICS_1889		0x010	/* ICS 1889 */
#define	PHY_MODEL_ICS_1890		0x020	/* ICS 1890 */
#define	PHY_MODEL_ICS_1892		0x030	/* ICS 1892 */

#define	PHY_OUI_ADHOC		0x000895	/* AdHoc */
#define	PHY_MODEL_ADHOC_AC101LF		0x120	/* Adhoc AC101LF */
#define	PHY_MODEL_ADHOC_AH101LF		0x210	/* AdHoc AH101LF */

#define	PHY_OUI_BROADCOM	0x001018	/* Broadcom */
#define	PHY_MODEL_BROADCOM_5221		0x1E0	/* Broadcom BCM5221 */

#define	PHY_OUI_ENABLE		0x0010DD	/* Enable */
#define	PHY_MODEL_ENABLE_EL40331	0x011	/* Enable EL40-331 */

#define	PHY_OUI_QUALITY		0x006051	/* Quality */
#define	PHY_MODEL_QUALITY_6612		0x010	/* Quality QS6612 */

#define	PHY_OUI_DAVICOM		0x00606E	/* Davicom */
#define	PHY_MODEL_DAVICOM_DM9101	0x000	/* Davicom DM9101 */

#define	PHY_OUI_SMSC		0x00A087	/* SMSC */
#define	PHY_MODEL_SMSC_83C180		0x050	/* SMSC 83C180 */

#define	PHY_OUI_INTEL		0x00AA00	/* Intel */
#define	PHY_MODEL_INTEL_82555		0x150	/* Intel 82555 Stand-alone */
#define	PHY_MODEL_INTEL_82562		0x320	/* Intel 82562 Stand-alone */
#define	PHY_MODEL_INTEL_82553		0x353	/* Intel 82553 Stand-alone */

#define	PHY_OUI_TDK		0x00C039	/* TDK */
#define	PHY_MODEL_TDK_78Q2120		0x140	/* TDK 78Q2120 */

#define	PHY_OUI_NS		0x080017	/* National Semiconductor */
#define	PHY_MODEL_NS_83840		0x000	/* NS 83840 Stand-alone */
#define	PHY_MODEL_NS_83843		0x010	/* NS 83843 Stand-alone */
#define	PHY_MODEL_NS_83846		0x020	/* NS 83846 Stand-alone */

#define	PHY_OUI_L1		0x1E0400	/* Level One */
#define	PHY_MODEL_L1_LXT97x		0x000	/* Level One LXT970/971 */

/* PHY ID Register macros */

#define	PHY_VENDOR_SHIFT       	22
#define	PHY_VENDOR_SIZE		(1 << PHY_VENDOR_SHIFT)
#define	PHY_VENDOR_MASK		(PHY_VENDOR_SIZE - 1)

#define	PHY_MODEL_SHIFT		10
#define	PHY_MODEL_SIZE		(1 << PHY_MODEL_SHIFT)
#define	PHY_MODEL_MASK		(PHY_MODEL_SIZE - 1)

#define	PHY_REV_SHIFT		4
#define	PHY_REV_SIZE		(1 << PHY_REV_SHIFT)
#define	PHY_REV_MASK		(PHY_REV_SIZE - 1)

#define	PHY_VENDOR_ID(id)      	(((id) >> PHY_MODEL_SHIFT) & PHY_VENDOR_MASK)
#define	PHY_MODEL_ID(id)	(((id) >> PHY_REV_SHIFT) & PHY_MODEL_MASK)
#define	PHY_MODEL_REV(id)	((id) & PHY_REV_MASK)

#define	PHY_OUI(id)		PHY_VENDOR_ID(id)
#define	PHY_MODEL(id)		((id) & PHY_MODEL_MASK)


#ifdef __cplusplus
}
#endif

#endif /* __PHYID_H__ */
